package com.javacodegeeks.nio.heapbytebuffer;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import java.nio.ByteBuffer;

import org.junit.Test;

public class HeapByteBufferIdentityCrisisTest {

    @Test
    public void shapeShift() {
        final ByteBuffer buffer = ByteBuffer.wrap("Hello world!".getBytes());
        assertTrue("Not a heap buffer", !buffer.isDirect());
        
        final ByteBuffer shapeShifter = ByteBuffer.allocateDirect(buffer.capacity()).put(getBytes(buffer));
        assertTrue("Not a direct buffer", shapeShifter.isDirect());
        
        shapeShifter.flip();
        byte [] contents = new byte[shapeShifter.capacity()];
        shapeShifter.get(contents);
        
        assertEquals("Invalid text", "Hello world!", new String(contents).trim());
    }
    
    private byte [] getBytes(final ByteBuffer buffer) {
        byte [] dest = new byte[buffer.remaining()];
        buffer.get(dest);
        return dest;
    }
}
