package com.javacodegeeks.nio.heapbytebuffer;

import static org.junit.Assert.assertTrue;

import java.nio.ByteBuffer;
import java.util.function.Predicate;

import org.junit.Test;

public class HeapByteBufferIdentityTest {

    @Test
    public void isHeapBuffer() {
        final ByteBuffer heapBuffer = ByteBuffer.allocate(5 * 10000);
        final ByteBuffer directBuffer = ByteBuffer.allocateDirect(5 * 10000);

        assertTrue("Must be direct", directBuffer.isDirect());
        assertTrue("Must not be direct", !heapBuffer.isDirect());
    }

    @Test
    public void persistenIdentityChecker() {
        final ByteBuffer buffer = ByteBuffer.allocate(5 * 10000);

        check(buffer, (a) -> !a.duplicate().isDirect());
        check(buffer, (a) -> !a.slice().isDirect());
        check(buffer, (a) -> !a.put("I am going to trick this buffer".getBytes()).isDirect());
        check(buffer, (a) -> !a.asIntBuffer().isDirect());
        check(buffer, (a) -> !a.asCharBuffer().isDirect());
        check(buffer, (a) -> !a.asFloatBuffer().isDirect());
    }

    private void check(final ByteBuffer buffer, final Predicate<? super ByteBuffer> action) {
        assertTrue(action.test(buffer));
    }
}
