package com.javacodegeeks.nio.heapbytebuffer;

import static org.junit.Assert.assertTrue;

import java.nio.ByteBuffer;

import org.junit.Before;
import org.junit.Test;

public class HeapByteBufferMemoryTest {

    private static final Runtime RUNTIME = Runtime.getRuntime();

    private ByteBuffer heapBuffer;
    private ByteBuffer directBuffer;
    private long startFreeMemory;

    @Before
    public void setUp() {
        this.startFreeMemory = RUNTIME.freeMemory();
    }

    @Test
    public void memoryUsage() {
        this.heapBuffer = ByteBuffer.allocate(5 * 100000);
        long afterHeapAllocation = RUNTIME.freeMemory();
        assertTrue("Heap memory did not increase", afterHeapAllocation < this.startFreeMemory);

        this.directBuffer = ByteBuffer.allocateDirect(5 * 100000);
        assertTrue("Heap memory must not increase", RUNTIME.freeMemory() >= afterHeapAllocation);
    }
}
